import javax.microedition.lcdui.*;
import java.util.*;

public class ElementForm extends Form implements CommandListener { 
    XMLBrowser  browser;
    Displayable parent;
    XMLElement  elem;
    
    ElementForm(XMLElement elem, XMLBrowser browser, Displayable parent) { 
        super(elem.getReadableName());
        this.browser = browser;
        this.elem = elem;
        this.parent = parent; 
        Vector attributes = elem.getAttributes();
        if (attributes != null) { 
            for (int i = 0, n = attributes.size(); i < n; i++) { 
                XMLAttribute attr = (XMLAttribute)attributes.elementAt(i);
                String name = attr.getName();
                if (name.equals("image")) { 
                    String imagePath = attr.getValue();
                    if (!imagePath.startsWith("/")) { 
                        imagePath = "/" + imagePath;
                    }
                    try {                         
                        Image image = Image.createImage(imagePath);
                        append(new ImageItem(null, image, ImageItem.LAYOUT_NEWLINE_BEFORE|ImageItem.LAYOUT_NEWLINE_AFTER, null));            
                    } catch (Exception x) {}
                } else if (name.equals("ref")) { 
                    String docPath = attr.getValue();
                    if (!docPath.startsWith("/")) { 
                        docPath = "/" + docPath;
                    }
                    XMLParser parser = browser.getParser(docPath);
                    browser.showElement(parser.getRoot(), parent);
                    return;                    
                } else if (!name.equals("name")) { 
                    append(new StringItem(attr.getName(), attr.getValue()));
                }
            }
        }
        String value = elem.getValue();
        if (value != null) { 
            append(new StringItem(null, value));
        }
        setCommandListener(this);
        if (elem.getSiblings() != null) { 
            addCommand(browser.SEARCH_CMD);
            addCommand(browser.SIBLINGS_CMD);
        }
        if (parent != null) { 
            addCommand(browser.BACK_CMD);
        } else { 
            addCommand(browser.QUIT_CMD);
        }
        Display.getDisplay(browser).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d)  
    {
        if (c == browser.SEARCH_CMD) { 
            new SearchBox(elem, browser, this);
        } else if (c == browser.SIBLINGS_CMD) { 
            new ElementList(elem, browser, this);
        } else if (c == browser.BACK_CMD) { 
            Display.getDisplay(browser).setCurrent(parent);
        } else { 
            browser.quit();
        }
    }
}