import javax.microedition.lcdui.*;
import java.util.*;

public class ElementList extends List implements CommandListener { 
    XMLBrowser  browser;
    Displayable parent;
    Vector      elements;
    XMLElement  element;

    ElementList(XMLElement element, XMLBrowser browser, Displayable parent) { 
        this(element.getReadableName(), element.getSiblings(), browser, parent);
        this.element = element;
        addCommand(browser.SEARCH_CMD);        
    }

    ElementList(String title, Vector elements, XMLBrowser browser, Displayable parent) { 
        super(title, IMPLICIT);
        this.elements = elements;
        this.parent = parent;
        this.browser = browser;
        for (int i = 0, n = elements.size(); i < n; i++) { 
            XMLElement elem = (XMLElement)elements.elementAt(i);
            append(elem.getReadableName(), browser.siblingImage);
        }
        setCommandListener(this);
        if (parent == null) { 
            addCommand(browser.QUIT_CMD);        
        } else { 
            addCommand(browser.BACK_CMD);        
        }
        Display.getDisplay(browser).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d)  
    {
        if (c == browser.SEARCH_CMD) { 
            new SearchBox(element, browser, this);
        } else if (c == browser.QUIT_CMD) { 
            browser.quit();
        } else if (c == browser.BACK_CMD) { 
            Display.getDisplay(browser).setCurrent(parent);
        } else { 
            int i = getSelectedIndex();
            if (i >= 0) { 
                browser.showElement((XMLElement)elements.elementAt(i), this);
            }
        }
    }
}