import java.io.*;
import java.util.*;

public class Locale { 
    private String readLine(Reader in) throws IOException { 
        int ch = in.read();
        if (ch < 0) { 
            return null;
        }
        StringBuffer buf = new StringBuffer();
        while (ch != '\n' && ch >= 0) { 
            if (ch != 0 && ch != '\r') { 
                buf.append((char)ch);
            }
            ch = in.read();
        }
        return buf.toString();
    }

    public Locale() { 
        this(System.getProperty("microedition.locale").substring(0, 2));
    }

    public Locale(String language) {
        this.language = language;
        if (!language.equals("en")) { 
            try { 
                InputStream in = getClass().getResourceAsStream("/locale." + language);
                if (in != null) {                     
                    Reader reader;
                    if (language.equals("ru")) { 
                        reader = new CyrillicWinReader(in);                    
                    } else { 
                        reader = new InputStreamReader(in);                    
                    }
                    String line;
                    hash = new Hashtable();
                    while ((line = readLine(reader)) != null) { 
                        int separator = line.indexOf(':');
                        String key = line.substring(0, separator).trim();
                        String value = line.substring(separator+1).trim();
                        hash.put(key, value);
                    }
                }
            } catch (IOException x) { 
            }
        }
    }

    public String getResource(String key) { 
        if (hash != null) { 
            String translation = (String)hash.get(key);
            if (translation != null) { 
                return translation;
            }
        }
        return key;
    }

    public String getLanguage() { 
        return language;
    }

    private Hashtable hash;
    private String    language;
}                       
            
