import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.util.*;
import java.io.*;

public class XMLBrowser extends MIDlet
{ 
    Locale locale = new Locale();

    Command QUIT_CMD;
    Command BACK_CMD;
    Command SIBLINGS_CMD;
    Command SEARCH_CMD;

    String filePath = "/data.xml";
    
    public void showElement(XMLElement elem, Displayable parent) { 
        Vector attributes = elem.getAttributes();
        if ((attributes != null 
             && (attributes.size() != 1 
                 || !"name".equals(((XMLAttribute)attributes.elementAt(0)).getName())))
            || elem.getValue() != null) 
        { 
            new ElementForm(elem, this, parent);
        } else { 
            new ElementList(elem, this, parent);
        }
    }

    XMLParser getParser(String url) { 
        if ("ru".equals(locale.getLanguage())) { 
            return new XMLParser(new CyrillicWinReader(getClass().getResourceAsStream(url)));
        } else { 
            return new XMLParser(url);
        }
    }

    public XMLBrowser() { 
        XMLParser parser;
        String language = getAppProperty("language");
        locale = new Locale(language != null ? language : "ru");
        QUIT_CMD = new Command(locale.getResource("Quit"), Command.BACK, 2);
        BACK_CMD = new Command(locale.getResource("Back"), Command.BACK, 2);
        SIBLINGS_CMD = new Command(locale.getResource("Siblings"), Command.ITEM, 1);
        SEARCH_CMD = new Command(locale.getResource("Search"), Command.ITEM, 2);
        parser = getParser(filePath);
        rootElem = parser.getRoot();
        try { 
            siblingImage = Image.createImage("/sibling.png");
        } catch (IOException err) {
            // ignore the image loading failure the application can recover.
        }
            
    }

    protected void destroyApp(boolean unconditional) {
    }    

    protected  void pauseApp() {
    }

    protected void startApp() 
    {
        showElement(rootElem, null);
    }

    public void quit() { 
        destroyApp(true);
        notifyDestroyed();
    }

    XMLElement rootElem;
    Image      siblingImage;
}    
           